var _excluded = ["theme"],
  _excluded2 = ["theme"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import background from "./background";
import borderMixIn from "./border";
import { getColor } from "../../../theme";
import alignItems from "./alignItems";
var fontColor = function fontColor(_ref) {
  var theme = _ref.theme,
    color = _ref.color;
  if (!color) return "";
  return "color: " + getColor(color)({
    theme: theme
  }) + ";";
};
var clearEmptyLines = function clearEmptyLines(str) {
  return str.replace(/^(?=\n)$|^\s*|\s*$|\n\n+/gm, "");
};
var transforms = {
  border: borderMixIn,
  background: background,
  color: fontColor,
  alignItems: alignItems
};
export var calculateStyles = function calculateStyles(_ref2) {
  var theme = _ref2.theme,
    styles = _objectWithoutPropertiesLoose(_ref2, _excluded);
  var result = "";
  for (var key in styles) {
    if (transforms[key] !== undefined) {
      var transformFuction = transforms[key];
      var transformFuctionResult = transformFuction && typeof transformFuction === "function" ? transformFuction(_objectSpread({
        theme: theme
      }, styles)) : "";
      result = result + transformFuctionResult;
      continue;
    }
    var value = styles[key];
    result = result + (key + ":" + value + ";");
  }
  return result;
};
export var pseudoSelectors = {
  _before: "&::before",
  _after: "&::after",
  _hover: "&:hover, &[data-hover]",
  _active: "&:active, &[data-active]",
  _focus: "&:focus, &[data-focus]",
  _focusWithin: "&:focus-within",
  _visited: "&:visited",
  _empty: "&:empty",
  _even: "&:nth-of-type(even)",
  _odd: "&:nth-of-type(odd)",
  _disabled: "&[disabled], &[aria-disabled=true], &[data-disabled]",
  _checked: "&[aria-checked=true]",
  _mixed: "&[aria-checked=mixed]",
  _selected: "&[aria-selected=true], [data-selected] > &",
  _invalid: "&[aria-invalid=true]",
  _pressed: "&[aria-pressed=true]",
  _readOnly: "&[aria-readonly=true], &[readonly]",
  _first: "&:first-of-type",
  _last: "&:last-of-type",
  _expanded: "&[aria-expanded=true]",
  _grabbed: "&[aria-grabbed=true]",
  _notFirst: "&:not(:first-of-type)",
  _notLast: "&:not(:last-of-type)",
  _groupHover: "[role=group]:hover &",
  _autofill: "&:-webkit-autofill",
  _placeholder: "&::placeholder"
};
export default (function (_ref3) {
  var theme = _ref3.theme,
    props = _objectWithoutPropertiesLoose(_ref3, _excluded2);
  var pseudo = "";
  for (var prop in props) {
    if (prop in pseudoSelectors) {
      var pseudoProp = prop;
      var pseudoStyles = props[pseudoProp];
      var styles = calculateStyles(_objectSpread({
        theme: theme
      }, pseudoStyles));
      pseudo = pseudo + ("\n      " + pseudoSelectors[pseudoProp] + "{ \n        " + styles + " \n      }");
    }
  }
  return clearEmptyLines(pseudo);
});